Leetcode:704. 二分查找

力扣题目链接

解题思路

首先很容易想到暴力解法,通过简单的遍历数组,来找到目标值,但这样的时间复杂度为O(n).

根据题目和提示,所给数组是①有序②无重复元素,满足二分查找的前提条件,因此本题可用二分查找来做.

二分查找的思路如下:

  • 设定左右指针
  • 找到中间位置mid,将数组分为左右两块区域
  • 若numsmid==target,则找到了目标值,返回该位置下标
  • 若numsmid>target,则说明目标值在左区域,将右指针移到中间
  • 若numsmid<target,则说明目标值在右区域,将左指针移到中间

二分查找的条件是查找范围不为空,即left<=right;每次查找都会将查找范围缩小为一半,因此最多的查找次数为\log_2N,时间复杂度为O(\log_N)

小细节:在二分查找之前,可以先判断目标值是否在查找范围内,这样可以提高效率.

代码如下:

复制代码
class Solution {
    public int search(int[] nums, int target) {
     int l = 0 , r = nums.length - 1;
     if ( target < nums[0] || target > nums[r]) return -1;
     while ( l <= r) {
         int mid = l + r >> 1;
         if (nums[mid] == target) return mid;
         else if (nums[mid] < target) l = mid + 1;
         else r = mid - 1;
     }
     return -1;
    }
}
相关推荐
其实防守也摸鱼13 小时前
个人学习 Pwn 思路:从基础到漏洞利用的进阶路径
大数据·前端·人工智能·chrome·算法·安全·网络安全
Nuanyt13 小时前
LeetCode Hot 100 链表专题(五)· 2 题(Java)
java·算法·leetcode·链表
w_zero_one16 小时前
递归算法(一)
java·开发语言·算法
圣保罗的大教堂16 小时前
leetcode 3736. 最小操作次数使数组元素相等 III 简单
leetcode
文丑颜不良啊17 小时前
LeetCode1881~1990题目解析
java·leetcode
风影同志7832418 小时前
20 个比特能装下多少行情?——实测拆解 Kronos 的 K 线分词器
算法
写的都是BUG18 小时前
APK 里的钥匙,一直就放在门口:聊聊加固真正该做什么
前端·算法
地平线开发者19 小时前
CLIP 的零样本分类:一组文本如何变成图像分类器?
算法
京东云开发者19 小时前
从“会生成”到“能生产”:萤火虫 AIGC 平台的 AI Infra 实践
算法·aigc·产品